Ext.namespace("dSS", "dSS.util");

dSS.util.GridToSVWindow = Ext.extend(Ext.Window, {
    constructor: function(config) {
        var records;

        if (config.separator === undefined) {
            config.separator = "\t";
        }

        if (config.ignore === undefined) {
            config.ignore = [];
        }

        // we were called from the toolbar, so its possible that there is
        // no device selection yet
        var sel = config.gridPanel.getSelectionModel();
        var all = false;
        if (!sel.hasSelection()) {
            sel.selectAll();
            all = true;
        }

        records = sel.getSelections();
        col = config.gridPanel.getColumnModel();
        cCount = col.getColumnCount(false);

        var svData = "";
        var svHeader = "";
        var sep = "";
        for (var i = 0; i < records.length; i++) {
            var line = "";
            for (var j = 0; j < cCount; j++) {
                if ((col.isHidden(j) === false) &&
                    (col.getColumnHeader(j) !== undefined)) {
                    var colId = col.getColumnId(j);
                    var ignore = false;

                    for (var ign = 0; ign < config.ignore.length; ign++) {
                        if (colId === config.ignore[ign]) {
                            ignore = true;
                            break;
                        }
                    }

                    if (ignore === true) {
                        continue;
                    }

                    // render sv header
                    if (i === 0) {
                        sep = "";
                        if ((j > 0) && (svHeader !== "")) {
                            sep = config.separator;
                        }

                        svHeader = svHeader + sep + col.getColumnHeader(j);
                    }

                    var val = records[i].get(colId);
                    if (val === undefined) {
                        val = "";
                    }

                    sep = "";
                    if ((j > 0) && (line !== "")) {
                        sep = config.separator;
                    }

                    line = line + sep + val;
                }
            }
            svData = svData + line + "<br/>";
        }

        svData = svHeader + "<br/>" + svData;

        if (all === true) {
            sel.clearSelections();
        }

        Ext.apply(this, {
            layout: "border",
            title: dSS._("Select text, right click, copy"),
            width: config.windowWidth,
            height: config.windowHeight,
            items: [
            new Ext.Panel({
                region: "center",
                autoScroll: true,
                layout: "fit",
                html: svData,
                bodyCfg: {
                    tag: 'pre'
                }
            })],
            buttons: [
            {
                text: dSS._("Close"),
                handler: this.close.createDelegate(this)
            }]
        });

        dSS.util.GridToSVWindow.superclass.constructor.apply(this, arguments);
    }
});

Ext.reg('dssutilgridtosvwindow', dSS.util.GridToSVWindow);

